﻿using System;
using System.IO;
using System.Windows.Forms;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Document;
using GrapeCity.ActiveReports.Viewer.Win; // Make sure to import ActiveReports namespace

namespace PrinterSettings
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            PrintDialog printDialog = new PrintDialog();
            printDialog.PrinterSettings = new System.Drawing.Printing.PrinterSettings();
            if (printDialog.ShowDialog() == DialogResult.OK)
            {
                var userPrinterSettings = printDialog.PrinterSettings;
                SetPrinterSettingsToReport(userPrinterSettings);
            }
        }
        private void SetPrinterSettingsToReport(System.Drawing.Printing.PrinterSettings userPrinterSettings)
        {
            PageReport rpt = new PageReport(new FileInfo(Path.Combine(Application.StartupPath, "Report.rdlx")));
            rpt.Document.Printer.PrinterSettings.Copy(userPrinterSettings); 
            GrapeCity.ActiveReports.PrintExtension.Print(rpt.Document, false, true);
        }
    }
}
