﻿namespace PrinterSettings
{
    public static class PrinterSettingExtension
    {
        public static void Copy(this GrapeCity.ActiveReports.Printing.IPrinterSettings p, System.Drawing.Printing.PrinterSettings printerSettings)
        {
            p.PrinterName = printerSettings.PrinterName;
            p.PrintFileName = string.IsNullOrEmpty(printerSettings.PrintFileName) ? "print" : printerSettings.PrintFileName;
            p.PrintToFile = printerSettings.PrintToFile;
            p.ToPage = printerSettings.ToPage;
            p.FromPage = printerSettings.FromPage;
            p.PrintRange.Copy(printerSettings.PrintRange);
            p.MinimumPage = printerSettings.MinimumPage;
            p.MaximumPage = printerSettings.MaximumPage;
            p.Duplex.Copy(printerSettings.Duplex);
            p.Copies = printerSettings.Copies;
            p.Collate = printerSettings.Collate;
        }
        private static void Copy(this GrapeCity.ActiveReports.Printing.PrintRange p, System.Drawing.Printing.PrintRange printRange)
        {
            switch (printRange)
            {
                case System.Drawing.Printing.PrintRange.AllPages:
                    p = GrapeCity.ActiveReports.Printing.PrintRange.AllPages;
                    break;
                case System.Drawing.Printing.PrintRange.Selection:
                    p = GrapeCity.ActiveReports.Printing.PrintRange.Selection;
                    break;
                case System.Drawing.Printing.PrintRange.CurrentPage:
                    p = GrapeCity.ActiveReports.Printing.PrintRange.CurrentPage;
                    break;
                case System.Drawing.Printing.PrintRange.SomePages:
                    p = GrapeCity.ActiveReports.Printing.PrintRange.SomePages;
                    break;
                default:
                    break;
            }
        }
        private static void Copy(this GrapeCity.ActiveReports.Printing.Duplex d, System.Drawing.Printing.Duplex duplex)
        {
            switch (duplex)
            {
                case System.Drawing.Printing.Duplex.Default:
                    d = GrapeCity.ActiveReports.Printing.Duplex.Default;
                    break;
                case System.Drawing.Printing.Duplex.Simplex:
                    d = GrapeCity.ActiveReports.Printing.Duplex.Simplex;
                    break;
                case System.Drawing.Printing.Duplex.Horizontal:
                    d = GrapeCity.ActiveReports.Printing.Duplex.Horizontal;
                    break;
                case System.Drawing.Printing.Duplex.Vertical:
                    d = GrapeCity.ActiveReports.Printing.Duplex.Vertical;
                    break;
                default:
                    d = GrapeCity.ActiveReports.Printing.Duplex.Default;
                    break;
            }
        }
        public static void Copy(this System.Drawing.Printing.PrinterSettings p, GrapeCity.ActiveReports.Printing.IPrinterSettings printerSettings)
        {
            p.PrinterName = printerSettings.PrinterName;
            p.PrintFileName = printerSettings.PrintFileName;
            p.PrintToFile = printerSettings.PrintToFile;
            p.ToPage = printerSettings.ToPage;
            p.FromPage = printerSettings.FromPage;
            p.PrintRange.Copy(printerSettings.PrintRange);
            p.MinimumPage = printerSettings.MinimumPage;
            p.MaximumPage = printerSettings.MaximumPage;
            p.Duplex.Copy(printerSettings.Duplex);
            p.Copies = printerSettings.Copies;
            p.Collate = printerSettings.Collate;
        }
        private static void Copy(this System.Drawing.Printing.PrintRange p, GrapeCity.ActiveReports.Printing.PrintRange printRange)
        {
            switch (printRange)
            {
                case GrapeCity.ActiveReports.Printing.PrintRange.AllPages:
                    p = System.Drawing.Printing.PrintRange.AllPages;
                    break;
                case GrapeCity.ActiveReports.Printing.PrintRange.Selection:
                    p = System.Drawing.Printing.PrintRange.Selection;
                    break;
                case GrapeCity.ActiveReports.Printing.PrintRange.CurrentPage:
                    p = System.Drawing.Printing.PrintRange.CurrentPage;
                    break;
                case GrapeCity.ActiveReports.Printing.PrintRange.SomePages:
                    p = System.Drawing.Printing.PrintRange.SomePages;
                    break;
                default:
                    break;
            }
        }
        private static void Copy(this System.Drawing.Printing.Duplex d, GrapeCity.ActiveReports.Printing.Duplex duplex)
        {
            switch (duplex)
            {
                case GrapeCity.ActiveReports.Printing.Duplex.Default:
                    d = System.Drawing.Printing.Duplex.Default;
                    break;
                case GrapeCity.ActiveReports.Printing.Duplex.Simplex:
                    d = System.Drawing.Printing.Duplex.Simplex;
                    break;
                case GrapeCity.ActiveReports.Printing.Duplex.Horizontal:
                    d = System.Drawing.Printing.Duplex.Horizontal;
                    break;
                case GrapeCity.ActiveReports.Printing.Duplex.Vertical:
                    d = System.Drawing.Printing.Duplex.Vertical;
                    break;
                default:
                    d = System.Drawing.Printing.Duplex.Default;
                    break;
            }
        }
    }
}
